'''
Asynchronous email delivery agent using IMAP
@author: Peeter Jyrviste
'''
import AbstractEmailDeliveryAgent
import imaplib, mailbox
from email.Parser import Parser

class AsynchronousDeliveryAgent(AbstractEmailDeliveryAgent.AbstractEmailDeliveryAgent):
    def __init__(self, url, port, login, password, destination):
        self.url = url
        self.port = port
        self.login = login
        self.password = password
        self.destination = destination
    
    "Email transformer for asynchronous IMAP connection, extends emailTransformer"
    def fetchMail(self):
        box = mailbox.mbox(self.destination, factory=None, create=True)
        parser = Parser()
        server = imaplib.IMAP4_SSL(self.url, self.port)
        server.login(self.login, self.password)
        messages = server.select()[1][0] #defaults to INBOX
        print 'Importing all', messages, 'messages.'
        resp, data = server.search(None, 'ALL')
        for num in data[0].split():
            resp, data = server.fetch(num, '(RFC822)')
            label = num + "/" + messages + ": " + resp
            print label
            emailMessage = parser.parsestr(data[0][1])
            box.add(emailMessage)
        server.close()
        server.logout()
        print 'Fetching complete.'
